/* create default XFolder configuration
   English version (001)
   (W) (C) 1998 Ulrich Mller */

call RxFuncAdd 'SysLoadFuncs', 'REXXUTIL', 'SysLoadFuncs'
call SysLoadFuncs

parse source dir;
parse var dir x1 x2 dir;
dir = filespec("D", dir)||filespec("P", dir)
pdir = left(dir, length(dir)-4)

/* these are the titles of the objects to be created */
OnlineReference     = "XFolder Online Reference";
ConfigFolder        = "XFolder Configuration Folder";
CommandLines        = "~Command lines";
OS2Win              = "~OS/2 window";
OS2Fullscreen       = "OS/2 ~fullscreen";
DosWin              = "~DOS window";
DOSFullscreen       = "DOS f~ullscreen";
CreateAnother       = "Create a~nother";
Folder              = "Folder";
ProgramObject       = "Program object";
QuickSettings       = "~Quick Settings";
DefaultView         = "~Default view for this folder";
IconView            = "Icon view";
TreeView            = "Tree view";
DetailsView         = "Details view";
AlwaysSort          = "Always sort this folder";
SmallIcons          = "Small icons for Icon and Tree views";
NormalIcons         = "Normal icons for Icon and Tree views";
ShowAllInTreeView   = "Show all objects in Tree view";
System              = "System";
OnlineReferenceFile = "xfldr001.inf";

/* do not change the following */
rc = SysCreateObject("WPProgram", OnlineReference, "<WP_INFO>", "EXENAME=view.exe;PARAMETERS="pdir||OnlineReferenceFile";OBJECTID=<XFOLDER_REF>", "R");
rc = SysCreateObject("WPShadow", OnlineReference, "<WP_DESKTOP>", "SHADOWID=<XFOLDER_REF>;OBJECTID=<XFOLDER_REFSHADOW2>;", "R");

rc = SysCreateObject("WPFolder", ConfigFolder, "<WP_DESKTOP>", "ICONVIEW=NONFLOWED,MINI;SHOWALLINTREEVIEW=YES;DEFAULTVIEW=TREE;SHOWALLINTREEVIEW=YES;OBJECTID=<XFOLDER_CONFIG>", "U");

rc = SysCreateObject("WPFolder", CommandLines, "<XFOLDER_CONFIG>", "DEFAULTVIEW=ICON;ICONVIEW=NONFLOWED,MINI;SHOWALLINTREEVIEW=YES;OBJECTID=<XFOLDER_CFG1>", "U");
    if (SysSearchPath("PATH", "CMDSHL.CMD") \= "") then
        rc = SysCreateObject("WPProgram", OS2Win||" (CmdShl)", "<XFOLDER_CFG1>", "EXENAME=cmdshl.cmd;PARAMETERS=%;PROGTYPE=WINDOWABLEVIO;CCVIEW=YES;OBJECTID=<XFOLDER_CMDSHL>;", "R");
    if (SysSearchPath("PATH", "BASH.EXE") \= "") then
        rc = SysCreateObject("WPProgram", OS2Win||" (bash)", "<XFOLDER_CFG1>", "EXENAME=bash.exe;PARAMETERS=%;PROGTYPE=WINDOWABLEVIO;CCVIEW=YES;OBJECTID=<XFOLDER_BASH>;", "R");
    if (SysSearchPath("PATH", "KSH.EXE") \= "") then
        rc = SysCreateObject("WPProgram", OS2Win||" (ksh)", "<XFOLDER_CFG1>", "EXENAME=ksh.exe;PARAMETERS=%;PROGTYPE=WINDOWABLEVIO;CCVIEW=YES;OBJECTID=<XFOLDER_KSH>;", "R");
    rc = SysCreateObject("WPProgram", OS2Win, "<XFOLDER_CFG1>", "EXENAME=*;PARAMETERS=%;PROGTYPE=WINDOWABLEVIO;CCVIEW=YES;OBJECTID=<XFOLDER_OS2WIN>;", "R");
    rc = SysCreateObject("WPProgram", OS2Fullscreen, "<XFOLDER_CFG1>", "EXENAME=*;PARAMETERS=%;PROGTYPE=FULLSCREEN;CCVIEW=YES;OBJECTID=<XFOLDER_OS2FULL>;", "R");
    rc = SysCreateObject("WPProgram", DosWin, "<XFOLDER_CFG1>", "EXENAME=*;PARAMETERS=%;PROGTYPE=WINDOWEDVDM;CCVIEW=YES;OBJECTID=<XFOLDER_DOSWIN>;", "R");
    rc = SysCreateObject("WPProgram", DosFullscreen, "<XFOLDER_CFG1>", "EXENAME=*;PARAMETERS=%;PROGTYPE=VDM;CCVIEW=YES;OBJECTID=<XFOLDER_DOSFULL>;", "R");

rc = SysCreateObject("WPFolder", CreateAnother, "<XFOLDER_CONFIG>", "DEFAULTVIEW=ICON;ICONVIEW=NONFLOWED,MINI;SHOWALLINTREEVIEW=YES;OBJECTID=<XFOLDER_CFG2>", "U");
    rc = SysCreateObject("WPFolder", Folder, "<XFOLDER_CFG2>", "TEMPLATE=YES;OBJECTID=<XFOLDER_FOLDERTEMPLATE>;", "R");
    rc = SysCreateObject("WPProgram", ProgramObject, "<XFOLDER_CFG2>", "TEMPLATE=YES;OBJECTID=<XFOLDER_PROGRAMTEMPLATE>;", "R");

rc = SysCreateObject("WPFolder", QuickSettings, "<XFOLDER_CONFIG>", "DEFAULTVIEW=ICON;ICONVIEW=NONFLOWED,MINI;SHOWALLINTREEVIEW=YES;OBJECTID=<XFOLDER_CFG3>", "U");
    rc = SysCreateObject("WPFolder", DefaultView, "<XFOLDER_CFG3>", "DEFAULTVIEW=ICON;ICONVIEW=NONFLOWED,MINI;SHOWALLINTREEVIEW=YES;OBJECTID=<XFOLDER_CFG3_1>", "U");
        rc = SysCreateObject("WPProgram", IconView, "<XFOLDER_CFG3_1>", "EXENAME="dir'deficon.cmd;CCVIEW=YES;MINIMIZED=YES;NOAUTOCLOSE=NO;OBJECTID=<XFOLDER_DEFICON>;', "R");
        rc = SysCreateObject("WPProgram", TreeView, "<XFOLDER_CFG3_1>", "EXENAME="dir'deftree.cmd;CCVIEW=YES;MINIMIZED=YES;NOAUTOCLOSE=NO;OBJECTID=<XFOLDER_DEFTREE>;', "R");
        rc = SysCreateObject("WPProgram", DetailsView, "<XFOLDER_CFG3_1>", "EXENAME="dir'defdetls.cmd;CCVIEW=YES;MINIMIZED=YES;NOAUTOCLOSE=NO;OBJECTID=<XFOLDER_DEFDETLS>;', "R");
    rc = SysCreateObject("WPProgram", AlwaysSort, "<XFOLDER_CFG3>", "EXENAME="dir'alwssort.cmd;MINIMIZED=YES;CCVIEW=YES;NOAUTOCLOSE=NO;OBJECTID=<XFOLDER_ALWSSORT>;', "R");
    rc = SysCreateObject("WPProgram", SmallIcons, "<XFOLDER_CFG3>", "EXENAME="dir'icosmall.cmd;CCVIEW=YES;MINIMIZED=YES;NOAUTOCLOSE=NO;OBJECTID=<XFOLDER_ICOSMALL>;', "R");
    rc = SysCreateObject("WPProgram", NormalIcons, "<XFOLDER_CFG3>", "EXENAME="dir'iconorm.cmd;CCVIEW=YES;MINIMIZED=YES;NOAUTOCLOSE=NO;OBJECTID=<XFOLDER_ICONORM>;', "R");
    rc = SysCreateObject("WPProgram", ShowAllInTreeView, "<XFOLDER_CFG3>", "EXENAME="dir'showall.cmd;CCVIEW=YES;MINIMIZED=YES;NOAUTOCLOSE=NO;OBJECTID=<XFOLDER_SHOWALL>;', "R");

if (SysSearchPath("PATH", "NETSCAPE.EXE") \= "") then
    rc = SysCreateObject("WPProgram", "Netscape (DDE)", "<XFOLDER_CONFIG>", "EXENAME="dir"netscdde.exe;OBJECTID=<XFOLDER_NETSCAPE>;", "R");

rc = SysCreateObject("WPFolder", "~XFolder", "<XFOLDER_CONFIG>", "DEFAULTVIEW=ICON;ICONVIEW=NONFLOWED,MINI;SHOWALLINTREEVIEW=YES;OBJECTID=<XFOLDER_CFG4>", "U");
    rc = SysCreateObject("WPShadow", OnlineReference, "<XFOLDER_CFG4>", "SHADOWID=<XFOLDER_REF>;OBJECTID=<XFOLDER_REFSHADOW>;", "R");
    rc = SysCreateObject("WPShadow", ConfigFolder, "<XFOLDER_CFG4>", "SHADOWID=<XFOLDER_CONFIG>;OBJECTID=<XFOLDER_CONFIGSHADOW>;", "R");
    rc = SysCreateObject("WPShadow", System, "<XFOLDER_CFG4>", "SHADOWID=<WP_SYSTEM>;OBJECTID=<XFOLDER_SYSTEMSHADOW>;", "R");

rc = SysCreateObject("WPProgram", "---", "<XFOLDER_CONFIG>", "OBJECTID=<XFOLDER_SEP1>;", "R");


